<template>
  <b-tooltip :label="tooltipContent()">
    <b-icon :icon="icon()"
            :type="`is-${color()}`"
            :size="`is-${size}`" />
  </b-tooltip>
</template>

<script lang="ts">
import { Trophy as TrophyType  } from '@/types/scores';
import { Size } from '@/types/sizes';
import { Component, Vue, Prop } from 'vue-property-decorator';
import { capitalize } from 'lodash';

@Component
export default class Trophy extends Vue {
  @Prop(String) readonly type: TrophyType;
  @Prop({ default: 'large' }) readonly size: Size;

  icon(): string {
    if (['paradise', 'gold', 'silver',
         'bronze'].includes(this.type))
      return 'trophy';
    if (['red', 'orange', 'green',
         'confirmed'].includes(this.type))
      return 'award';

    return 'circle-notch';
  }

  color() {
    return {
      paradise: 'grey-light',
      gold: 'gold',
      silver: 'blue',
      bronze: 'bronze',
      red: 'red',
      orange: 'orange',
      green: 'green',
      confirmed: 'blue',
      newbie: 'orange',
    }[this.type];
  }

  tooltipContent(): string {
    return `${capitalize(this.$t('levels.name'))}
            ${capitalize(this.$t('levels.' + this.type))}`;
  }
}
</script>
